/*
 *  upkg: tool for manipulating Unreal Tournament packages.
 *  Copyright © 2009-2011 Nick Bowler
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TEXTURE_H_
#define TEXTURE_H_

#include <glib-object.h>
#include <uobject/uobject.h>

#define ENGINE_TEXTURE_TYPE (engine_texture_get_type())
#define ENGINE_TEXTURE(obj) \
	G_TYPE_CHECK_INSTANCE_CAST(obj, ENGINE_TEXTURE_TYPE, EngineTexture)
#define ENGINE_TEXTURE_CLASS(class) \
	G_TYPE_CHECK_CLASS_CAST(class, ENGINE_TEXTURE_TYPE, EngineTextureClass)
#define ENGINE_IS_TEXTURE(obj) \
	G_TYPE_CHECK_INSTANCE_TYPE(obj, ENGINE_TEXTURE_TYPE)
#define ENGINE_IS_TEXTURE_CLASS(class) \
	G_TYPE_CHECK_CLASS_TYPE(class, ENGINE_TEXTURE_TYPE, EngineTextureClass)

typedef struct EngineTexture      EngineTexture;
typedef struct EngineTextureClass EngineTextureClass;

struct EngineTexture {
	UObject parent;

	UObject *palette;

	unsigned int usize,  vsize;
	unsigned int uclamp, vclamp;
	unsigned int ubits,  vbits;
};

struct EngineTextureClass {
	UObjectClass parent;
};

GType engine_texture_get_type(void);
void texture_register(GTypeModule *m);

#endif
